sequence m_usage m_usage={}-- vbo usage flag
sequence m_buffer m_buffer={}
sequence m_index m_index={}
sequence m_nverts m_nverts={}
sequence m_size m_size={}-- size of attribute       
sequence m_format m_format={}-- readpixels image format
sequence m_type m_type={}-- FLOAT or HALF_FLOAT
sequence m_bytes_per_component m_bytes_per_component={}





sequence m_ids m_ids={}
atom mc
atom cmid
cmid=0
function m_id(atom id)
	mc=find(id,m_ids)
	if not mc then return 0 end if
	return mc
end function



global function RenderVertexArray(atom nverts, atom size, atom typ)
	cmid+=1
	m_ids&=cmid
	m_usage=append(m_usage,GL_STREAM_COPY)-- vbo usage flag
	m_buffer=append(m_buffer,0)
	m_index=append(m_index,0)
	m_nverts=append(m_nverts,nverts)
	m_size=append(m_size,size)-- size of attribute
	m_format=append(m_format,{})-- readpixels image format
	m_type=append(m_type,typ)-- FLOAT or HALF_FLOAT
	m_bytes_per_component=append(m_bytes_per_component,{})
	if not m_id(cmid) then return 0 end if
	if m_type[mc]=GL_HALF_FLOAT_NV then m_bytes_per_component[mc]=2
	elsif m_type[mc]=GL_FLOAT then m_bytes_per_component[mc]=4
	elsif m_type[mc]=GL_UNSIGNED_INT then m_bytes_per_component[mc]=4
	else return 0
	end if
	m_buffer[mc]=allocate_glint(m_buffer[mc])
	glGenBuffersARB(1, m_buffer[mc])
	m_buffer[mc]=peek_free_glint(m_buffer[mc])
	if m_type[mc]=GL_HALF_FLOAT_NV or m_type[mc]=GL_FLOAT then
	glBindBufferARB(GL_PIXEL_PACK_BUFFER_EXT, m_buffer[mc])
	glBufferDataARB(GL_PIXEL_PACK_BUFFER_EXT, m_nverts[mc]*m_size[mc]*m_bytes_per_component[mc], 0, m_usage[mc])-- undefined data
	glBindBufferARB(GL_PIXEL_PACK_BUFFER_EXT, 0)
	elsif m_type[mc]=GL_UNSIGNED_INT then
	glBindBufferARB(GL_ELEMENT_ARRAY_BUFFER_ARB, m_buffer[mc])
	glBufferDataARB(GL_ELEMENT_ARRAY_BUFFER_ARB, m_nverts[mc]*m_size[mc]*m_bytes_per_component[mc], 0, GL_STATIC_DRAW_ARB)-- undefined data
	glBindBufferARB(GL_PIXEL_PACK_BUFFER_EXT, 0)
	end if
	if m_size[mc]=1 then m_format[mc]=GL_LUMINANCE
	elsif m_size[mc]=3 then m_format[mc]=GL_RGB
--	elsif m_size[mc]=4 then m_format[mc]=GL_RGBA
	elsif m_size[mc]=4 then m_format[mc]=GL_RGBA
	end if
	return cmid
end function

global procedure RenderVertexArray_resize(atom r, atom nverts)
	if not m_id(r) then return end if
	m_nverts[mc]=nverts
	glBindBufferARB(GL_PIXEL_PACK_BUFFER_EXT, m_buffer[mc])
	glBufferDataARB(GL_PIXEL_PACK_BUFFER_EXT, m_nverts[mc]*m_size[mc]*m_bytes_per_component[mc], 0, m_usage[mc])-- undefined data
	glBindBufferARB(GL_PIXEL_PACK_BUFFER_EXT, 0)
end procedure

global procedure RenderVertexArray_free(atom r)
	if not m_id(r) then return end if
	m_buffer[mc]=allocate_glint(m_buffer)
	glDeleteBuffersARB(1, m_buffer)
	m_buffer[mc]=peek_free_glint(m_buffer[mc])
end procedure

global procedure RenderVertexArray_LoadData(atom r, atom data)                -- load vertex data from memory
	if not m_id(r) then return end if
	glBindBufferARB(GL_PIXEL_PACK_BUFFER_EXT, m_buffer[mc])
	glBufferDataARB(GL_PIXEL_PACK_BUFFER_EXT, m_nverts[mc]*m_size[mc]*m_bytes_per_component[mc], data, m_usage[mc])
	glBindBufferARB(GL_PIXEL_PACK_BUFFER_EXT, 0)
end procedure

global procedure RenderVertexArray_LoadDataIndex(atom r, atom data)                -- load vertex data from memory
	if not m_id(r) then return end if
	glBindBufferARB(GL_ELEMENT_ARRAY_BUFFER_ARB, m_buffer[mc])
	glBufferDataARB(GL_ELEMENT_ARRAY_BUFFER_ARB, m_nverts[mc]*m_size[mc]*m_bytes_per_component[mc], data, GL_STATIC_DRAW_ARB)
	glBindBufferARB(GL_PIXEL_PACK_BUFFER_EXT, 0)
end procedure

global procedure RenderVertexArray_Read_ATIFIX(atom r, atom buffer, atom w, atom h)   -- read vertex data from frame buffer
atom mem
	if not m_id(r) then return end if
	--glBindBufferARB(GL_PIXEL_PACK_BUFFER_EXT, m_buffer[mc])
	-- read from frame buffer to buffer object
	glReadBuffer(buffer)
	mem=allocate(w*h*16)--will use the max size for now
	glReadPixels(0, 0, w, h, m_format[mc], m_type[mc], mem)
	glBindBufferARB(GL_PIXEL_PACK_BUFFER_EXT, m_buffer[mc])
	glBufferDataARB(GL_PIXEL_PACK_BUFFER_EXT, w*h*m_size[mc]*m_bytes_per_component[mc], mem, m_usage[mc])
	glBindBufferARB(GL_PIXEL_PACK_BUFFER_EXT, 0)
	free(mem)
--	glReadPixels(0, 0, w, h, m_format[mc], m_type[mc], 0)
	--glBindBufferARB(GL_PIXEL_PACK_BUFFER_EXT, 0)
end procedure


global procedure RenderVertexArray_Read(atom r, atom buffer, atom w, atom h)   -- read vertex data from frame buffer
	if not m_id(r) then return end if
	glBindBufferARB(GL_PIXEL_PACK_BUFFER_EXT, m_buffer[mc])
	-- read from frame buffer to buffer object
	glReadBuffer(buffer)
	glReadPixels(0, 0, w, h, m_format[mc], m_type[mc], 0)
	glBindBufferARB(GL_PIXEL_PACK_BUFFER_EXT, 0)
end procedure

global procedure RenderVertexArray_Read2(atom r, atom buffer, atom w, atom h)   -- read vertex data from frame buffer
	if not m_id(r) then return end if
	glBindBufferARB(GL_PIXEL_PACK_BUFFER_EXT, m_buffer[mc])
	-- read from frame buffer to buffer object
	glReadBuffer(buffer)
	glReadPixels(0, 0, w, h, GL_BGRA, m_type[mc], 0)
	glBindBufferARB(GL_PIXEL_PACK_BUFFER_EXT, 0)
end procedure

global procedure RenderVertexArray_SetPointer(atom r, atom index)
	-- bind buffer object to vertex array 
	if not m_id(r) then return end if
	glBindBufferARB(GL_ARRAY_BUFFER, m_buffer[mc])
	glVertexAttribPointerARB(index, m_size[mc], m_type[mc], 0, 0, 0)
	glBindBufferARB(GL_ARRAY_BUFFER, 0)
end procedure

global procedure RenderVertexArray_SetIndexPointer(atom r)
	-- bind buffer object to vertex array 
	if not m_id(r) then return end if
	glBindBufferARB(GL_ELEMENT_ARRAY_BUFFER_ARB, m_buffer[mc])
--	glVertexAttribPointerARB(index, m_size[mc], m_type[mc], 0, 0, 0)
--	glBindBufferARB(GL_ELEMENT_ARRAY_BUFFER_ARB, 0)
end procedure

global procedure RenderVertexArray_SetPointer_VertexArray(atom r)
	-- bind buffer object to vertex array 
	if not m_id(r) then return end if
	glBindBufferARB(GL_ARRAY_BUFFER, m_buffer[mc])
	glVertexPointer(m_size[mc], m_type[mc], 0, 0)
	glBindBufferARB(GL_ARRAY_BUFFER, 0)
end procedure
