include get.e
include dll.e
include machine.e
include misc.e
constant opengl32=open_dll("opengl32.dll")
constant gdi32=open_dll("gdi32.dll")
constant user32=open_dll("user32.dll")
constant kernel32=open_dll("kernel32")



global function peekd(object ptr)
sequence ret
	if atom(ptr) then return float64_to_atom(peek({ptr,8})) end if
	ret=repeat(0,ptr[2])
	ptr=ptr[1]
	for i = 1 to length(ret) do
		ret[i]=float64_to_atom(peek({ptr,8})) ptr+=8
	end for
	return ret
end function


global function HIWORD(atom val)
	return and_bits(floor(val/#10000),#FFFF)
end function

global function LOWORD(atom val)
	return and_bits(val,#FFFF)
end function

global function peek_string(atom ptr)
atom optr
	optr=ptr
	while peek(ptr) do ptr+=1 end while
	return peek({optr,ptr-optr})
end function

global function allocatez(atom size)
atom ret
	if size=0 then return 0 end if
	ret=allocate(size)
	mem_set(ret,0,size)
	return ret
end function

global procedure freez(atom ptr)
if ptr then free(ptr) end if
end procedure

global function word(object a)
	if sequence(a) then
		return a[1]+#100*a[2]
	else
		return and_bits(#FF,a)&floor(a/#100)
	end if
end function

global constant messages={
{"WM_CREATE",#0001},
{"WM_DESTROY",#0002},
{"WM_MOVE",#0003},
{"WM_SIZE",#0005},
{"WM_ACTIVATE",#0006},
{"WM_SETFOCUS",#0007},
{"WM_KILLFOCUS",#0008},
{"WM_ENABLE",#000A},
{"WM_SETREDRAW",#000B},
{"WM_SETTEXT",#000C},
{"WM_GETTEXT",#000D},
{"WM_GETTEXTLENGTH",#000E},
{"WM_PAINT",#000F},
{"WM_CLOSE",#0010},
{"WM_QUERYENDSESSION",#0011},
{"WM_QUIT",#0012},
{"WM_QUERYOPEN",#0013},
{"WM_ERASEBKGND",#0014},
{"WM_SYSCOLORCHANGE",#0015},
{"WM_ENDSESSION",#0016},
{"WM_SHOWWINDOW",#0018},
{"WM_WININICHANGE",#001A},
{"WM_DEVMODECHANGE",#001B},
{"WM_ACTIVATEAPP",#001C},
{"WM_FONTCHANGE",#001D},
{"WM_TIMECHANGE",#001E},
{"WM_CANCELMODE",#001F},
{"WM_SETCURSOR",#0020},
{"WM_MOUSEACTIVATE",#0021},
{"WM_CHILDACTIVATE",#0022},
{"WM_QUEUESYNC",#0023},
{"WM_GETMINMAXINFO",#0024},
{"WM_PAINTICON",#0026},
{"WM_ICONERASEBKGND",#0027},
{"WM_NEXTDLGCTL",#0028},
{"WM_SPOOLERSTATUS",#002A},
{"WM_DRAWITEM",#002B},
{"WM_MEASUREITEM",#002C},
{"WM_DELETEITEM",#002D},
{"WM_VKEYTOITEM",#002E},
{"WM_CHARTOITEM",#002F},
{"WM_SETFONT",#0030},
{"WM_GETFONT",#0031},
{"WM_SETHOTKEY",#0032},
{"WM_GETHOTKEY",#0033},
{"WM_QUERYDRAGICON",#0037},
{"WM_COMPAREITEM",#0039},
{"WM_COMPACTING",#0041},
{"WM_COMMNOTIFY",#0044},
{"WM_WINDOWPOSCHANGING",#0046},
{"WM_WINDOWPOSCHANGED",#0047},
{"WM_POWER",#0048},
{"WM_COPYDATA",#004A},
{"WM_CANCELJOURNAL",#004B},
{"WM_NOTIFY",#004E},
{"WM_INPUTLANGCHANGEREQUEST",#0050},
{"WM_INPUTLANGCHANGE",#0051},
{"WM_TCARD",#0052},
{"WM_HELP",#0053},
{"WM_USERCHANGED",#0054},
{"WM_NOTIFYFORMAT",#0055},
{"WM_CONTEXTMENU",#007B},
{"WM_STYLECHANGING",#007C},
{"WM_STYLECHANGED",#007D},
{"WM_DISPLAYCHANGE",#007E},
{"WM_GETICON",#007F},
{"WM_SETICON",#0080},
{"WM_NCCREATE",#0081},
{"WM_NCDESTROY",#0082},
{"WM_NCCALCSIZE",#0083},
{"WM_NCHITTEST",#0084},
{"WM_NCPAINT",#0085},
{"WM_NCACTIVATE",#0086},
{"WM_GETDLGCODE",#0087},
{"WM_NCMOUSEMOVE",#00A0},
{"WM_NCLBUTTONDOWN",#00A1},
{"WM_NCLBUTTONUP",#00A2},
{"WM_NCLBUTTONDBLCLK",#00A3},
{"WM_NCRBUTTONDOWN",#00A4},
{"WM_NCRBUTTONUP",#00A5},
{"WM_NCRBUTTONDBLCLK",#00A6},
{"WM_NCMBUTTONDOWN",#00A7},
{"WM_NCMBUTTONUP",#00A8},
{"WM_NCMBUTTONDBLCLK",#00A9},
--{"WM_KEYFIRST",#0100},
{"WM_KEYDOWN",#0100},
{"WM_KEYUP",#0101},
{"WM_CHAR",#0102},
{"WM_DEADCHAR",#0103},
{"WM_SYSKEYDOWN",#0104},
{"WM_SYSKEYUP",#0105},
{"WM_SYSCHAR",#0106},
{"WM_SYSDEADCHAR",#0107},
--{"WM_KEYLAST",#0108},
{"WM_IME_STARTCOMPOSITION",#010D},
{"WM_IME_ENDCOMPOSITION",#010E},
{"WM_IME_COMPOSITION",#010F},
--{"WM_IME_KEYLAST",#010F},
{"WM_INITDIALOG",#0110},
{"WM_COMMAND",#0111},
{"WM_SYSCOMMAND",#0112},
{"WM_TIMER",#0113},
{"WM_HSCROLL",#0114},
{"WM_VSCROLL",#0115},
{"WM_INITMENU",#0116},
{"WM_INITMENUPOPUP",#0117},
{"WM_MENUSELECT",#011F},
{"WM_MENUCHAR",#0120},
{"WM_ENTERIDLE",#0121},
{"WM_CTLCOLORMSGBOX",#0132},
{"WM_CTLCOLOREDIT",#0133},
{"WM_CTLCOLORLISTBOX",#0134},
{"WM_CTLCOLORBTN",#0135},
{"WM_CTLCOLORDLG",#0136},
{"WM_CTLCOLORSCROLLBAR",#0137},
{"WM_CTLCOLORSTATIC",#0138},
--{"WM_MOUSEFIRST",#0200},
{"WM_MOUSEMOVE",#0200},
{"WM_LBUTTONDOWN",#0201},
{"WM_LBUTTONUP",#0202},
{"WM_LBUTTONDBLCLK",#0203},
{"WM_RBUTTONDOWN",#0204},
{"WM_RBUTTONUP",#0205},
{"WM_RBUTTONDBLCLK",#0206},
{"WM_MBUTTONDOWN",#0207},
{"WM_MBUTTONUP",#0208},
{"WM_MBUTTONDBLCLK",#0209},
{"WM_MOUSEWHEEL",#020A},
--{"WM_MOUSELAST",#0209},
{"WM_PARENTNOTIFY",#0210},
{"WM_ENTERMENULOOP",#0211},
{"WM_EXITMENULOOP",#0212},
{"WM_NEXTMENU",#0213},
{"WM_SIZING",#0214},
{"WM_CAPTURECHANGED",#0215},
{"WM_MOVING",#0216},
{"WM_POWERBROADCAST",#0218},
{"WM_DEVICECHANGE",#0219},
{"WM_IME_SETCONTEXT",#0281},
{"WM_IME_NOTIFY",#0282},
{"WM_IME_CONTROL",#0283},
{"WM_IME_COMPOSITIONFULL",#0284},
{"WM_IME_SELECT",#0285},
{"WM_IME_CHAR",#0286},
{"WM_IME_KEYDOWN",#0290},
{"WM_IME_KEYUP",#0291},
{"WM_MDICREATE",#0220},
{"WM_MDIDESTROY",#0221},
{"WM_MDIACTIVATE",#0222},
{"WM_MDIRESTORE",#0223},
{"WM_MDINEXT",#0224},
{"WM_MDIMAXIMIZE",#0225},
{"WM_MDITILE",#0226},
{"WM_MDICASCADE",#0227},
{"WM_MDIICONARRANGE",#0228},
{"WM_MDIGETACTIVE",#0229},
{"WM_MDISETMENU",#0230},
{"WM_ENTERSIZEMOVE",#0231},
{"WM_EXITSIZEMOVE",#0232},
{"WM_DROPFILES",#0233},
{"WM_MDIREFRESHMENU",#0234},
{"WM_MOUSEHOVER",#02A1},
{"WM_MOUSELEAVE",#02A3},
{"WM_CUT",#0300},
{"WM_COPY",#0301},
{"WM_PASTE",#0302},
{"WM_CLEAR",#0303},
{"WM_UNDO",#0304},
{"WM_RENDERFORMAT",#0305},
{"WM_RENDERALLFORMATS",#0306},
{"WM_DESTROYCLIPBOARD",#0307},
{"WM_DRAWCLIPBOARD",#0308},
{"WM_PAINTCLIPBOARD",#0309},
{"WM_VSCROLLCLIPBOARD",#030A},
{"WM_SIZECLIPBOARD",#030B},
{"WM_ASKCBFORMATNAME",#030C},
{"WM_CHANGECBCHAIN",#030D},
{"WM_HSCROLLCLIPBOARD",#030E},
{"WM_QUERYNEWPALETTE",#030F},
{"WM_PALETTEISCHANGING",#0310},
{"WM_PALETTECHANGED",#0311},
{"WM_HOTKEY",#0312},
{"WM_PRINT",#0317},
{"WM_PRINTCLIENT",#0318}
--{"WM_HANDHELDFIRST",#0358},
--{"WM_HANDHELDLAST",#035F},
--{"WM_AFXFIRST",#0360},
--{"WM_AFXLAST",#037F},
--{"WM_PENWINFIRST",#0380},
--{"WM_PENWINLAST",#038F}
}






global constant LR_DEFAULTCOLOR =0
global constant LR_MONOCHROME =1
global constant LR_COLOR =2
global constant LR_COPYRETURNORG =4
global constant LR_COPYDELETEORG =8
global constant LR_LOADFROMFILE =16
global constant LR_LOADTRANSPARENT =32
global constant LR_LOADREALSIZE =128
global constant LR_LOADMAP3DCOLORS =4096
global constant LR_CREATEDIBSECTION =8192
global constant LR_COPYFROMRESOURCE =#4000
global constant LR_SHARED =32768


global constant IMAGE_BITMAP	=0
global constant IMAGE_ICON	=1
global constant IMAGE_CURSOR	=2
global constant IMAGE_ENHMETAFILE	=3




global constant VK_LBUTTON	=1
global constant VK_RBUTTON	=2
global constant VK_CANCEL	=3
global constant VK_MBUTTON	=4
global constant VK_XBUTTON1	=5
global constant VK_XBUTTON2	=6
global constant VK_BACK	=8
global constant VK_TAB	=9
global constant VK_CLEAR	=12
global constant VK_RETURN	=13
global constant VK_SHIFT	=16
global constant VK_CONTROL	=17
global constant VK_MENU	=18
global constant VK_PAUSE	=19
global constant VK_CAPITAL	=20
global constant VK_KANA	=#15
global constant VK_HANGEUL	=#15
global constant VK_HANGUL	=#15
global constant VK_JUNJA	=#17
global constant VK_FINAL	=#18
global constant VK_HANJA	=#19
global constant VK_KANJI	=#19
global constant VK_ESCAPE	=#1B
global constant VK_CONVERT	=#1C
global constant VK_NONCONVERT	=#1D
global constant VK_ACCEPT	=#1E
global constant VK_MODECHANGE	=#1F
global constant VK_SPACE	=32
global constant VK_PRIOR	=33
global constant VK_NEXT	=34
global constant VK_END	=35
global constant VK_HOME	=36
global constant VK_LEFT	=37
global constant VK_UP	=38
global constant VK_RIGHT	=39
global constant VK_DOWN	=40
global constant VK_SELECT	=41
global constant VK_PRINT	=42
global constant VK_EXECUTE	=43
global constant VK_SNAPSHOT	=44
global constant VK_INSERT	=45
global constant VK_DELETE	=46
global constant VK_HELP	=47
global constant VK_LWIN	=#5B
global constant VK_RWIN	=#5C
global constant VK_APPS	=#5D
global constant VK_SLEEP	=#5F
global constant VK_NUMPAD0	=#60
global constant VK_NUMPAD1	=#61
global constant VK_NUMPAD2	=#62
global constant VK_NUMPAD3	=#63
global constant VK_NUMPAD4	=#64
global constant VK_NUMPAD5	=#65
global constant VK_NUMPAD6	=#66
global constant VK_NUMPAD7	=#67
global constant VK_NUMPAD8	=#68
global constant VK_NUMPAD9	=#69
global constant VK_MULTIPLY	=#6A
global constant VK_ADD	=#6B
global constant VK_SEPARATOR	=#6C
global constant VK_SUBTRACT	=#6D
global constant VK_DECIMAL	=#6E
global constant VK_DIVIDE	=#6F
global constant VK_F1	=#70
global constant VK_F2	=#71
global constant VK_F3	=#72
global constant VK_F4	=#73
global constant VK_F5	=#74
global constant VK_F6	=#75
global constant VK_F7	=#76
global constant VK_F8	=#77
global constant VK_F9	=#78
global constant VK_F10	=#79
global constant VK_F11	=#7A
global constant VK_F12	=#7B
global constant VK_F13	=#7C
global constant VK_F14	=#7D
global constant VK_F15	=#7E
global constant VK_F16	=#7F
global constant VK_F17	=#80
global constant VK_F18	=#81
global constant VK_F19	=#82
global constant VK_F20	=#83
global constant VK_F21	=#84
global constant VK_F22	=#85
global constant VK_F23	=#86
global constant VK_F24	=#87
global constant VK_NUMLOCK	=#90
global constant VK_SCROLL	=#91
global constant VK_LSHIFT	=#A0
global constant VK_RSHIFT	=#A1
global constant VK_LCONTROL	=#A2
global constant VK_RCONTROL	=#A3
global constant VK_LMENU	=#A4
global constant VK_RMENU	=#A5
global constant VK_BROWSER_BACK	=#A6
global constant VK_BROWSER_FORWARD	=#A7
global constant VK_BROWSER_REFRESH	=#A8
global constant VK_BROWSER_STOP	=#A9
global constant VK_BROWSER_SEARCH	=#AA
global constant VK_BROWSER_FAVORITES	=#AB
global constant VK_BROWSER_HOME	=#AC
global constant VK_VOLUME_MUTE	=#AD
global constant VK_VOLUME_DOWN	=#AE
global constant VK_VOLUME_UP	=#AF
global constant VK_MEDIA_NEXT_TRACK	=#B0
global constant VK_MEDIA_PREV_TRACK	=#B1
global constant VK_MEDIA_STOP	=#B2
global constant VK_MEDIA_PLAY_PAUSE	=#B3
global constant VK_LAUNCH_MAIL	=#B4
global constant VK_LAUNCH_MEDIA_SELECT	=#B5
global constant VK_LAUNCH_APP1	=#B6
global constant VK_LAUNCH_APP2	=#B7
global constant VK_OEM_1	=#BA
global constant VK_OEM_PLUS	=#BB
global constant VK_OEM_COMMA	=#BC
global constant VK_OEM_MINUS	=#BD
global constant VK_OEM_PERIOD	=#BE
global constant VK_OEM_2	=#BF
global constant VK_OEM_3	=#C0
global constant VK_OEM_4	=#DB
global constant VK_OEM_5	=#DC
global constant VK_OEM_6	=#DD
global constant VK_OEM_7	=#DE
global constant VK_OEM_8	=#DF
global constant VK_OEM_102	=#E2
global constant VK_PROCESSKEY	=#E5
global constant VK_PACKET	=#E7
global constant VK_ATTN	=#F6
global constant VK_CRSEL	=#F7
global constant VK_EXSEL	=#F8
global constant VK_EREOF	=#F9
global constant VK_PLAY	=#FA
global constant VK_ZOOM	=#FB
global constant VK_NONAME	=#FC
global constant VK_PA1	=#FD
global constant VK_OEM_CLEAR	=#FE


global constant WS_CHILDWINDOW	=#40000000
global constant WS_ICONIC	=#20000000
global constant WS_OVERLAPPEDWINDOW	=#CF0000

global constant IDC_ARROW =32512
global constant IDC_IBEAM =32513
global constant IDC_WAIT =32514
global constant IDC_CROSS =32515
global constant IDC_UPARROW =32516
global constant IDC_SIZENWSE =32642
global constant IDC_SIZENESW =32643
global constant IDC_SIZEWE =32644
global constant IDC_SIZENS =32645
global constant IDC_SIZEALL =32646
global constant IDC_NO =32648
global constant IDC_HAND =32649
global constant IDC_APPSTARTING =32650
global constant IDC_HELP =32651
global constant IDC_ICON =32641
global constant IDC_SIZE =32640

global constant IDI_APPLICATION =32512
global constant IDI_HAND =32513
global constant IDI_QUESTION =32514
global constant IDI_EXCLAMATION =32515
global constant IDI_ASTERISK =32516
global constant IDI_WINLOGO =32517

global constant PM_NOREMOVE        = #0000
global constant PM_REMOVE          = #0001
global constant PM_NOYIELD         = #0002

global constant SW_HIDE             =0
global constant SW_SHOWNORMAL       =1
global constant SW_SHOWMINIMIZED    =2
global constant SW_SHOWMAXIMIZED    =3
global constant SW_SHOWNOACTIVATE   =4
global constant SW_SHOW             =5
global constant SW_MINIMIZE         =6
global constant SW_SHOWMINNOACTIVE  =7
global constant SW_SHOWNA           =8
global constant SW_RESTORE          =9


global constant SC_SIZE =#F000          
global constant SC_MOVE =#F010          
global constant SC_MINIMIZE =#F020      
global constant SC_MAXIMIZE =#F030
global constant SC_NEXTWINDOW =#F040
global constant SC_PREVWINDOW =#F050
global constant SC_CLOSE =#F060
global constant SC_VSCROLL =#F070
global constant SC_HSCROLL =#F080
global constant SC_MOUSEMENU =#F090
global constant SC_KEYMENU =#F100
global constant SC_ARRANGE =#F110
global constant SC_RESTORE =#F120
global constant SC_TASKLIST =#F130
global constant SC_SCREENSAVE =#F140
global constant SC_HOTKEY =#F150
global constant SC_DEFAULT =#F160
global constant SC_MONITORPOWER =#F170
global constant SC_CONTEXTHELP =#F180
global constant SC_PROPERTIES =#E005
global constant SC_TOOLBAR    =#E00E

global constant WM_CREATE                       =#0001
global constant WM_DESTROY                      =#0002
global constant WM_MOVE                         =#0003
global constant WM_SIZE                         =#0005
global constant WM_ACTIVATE                     =#0006
global constant WM_SETFOCUS                     =#0007
global constant WM_KILLFOCUS                    =#0008
global constant WM_ENABLE                       =#000A
global constant WM_SETREDRAW                    =#000B
global constant WM_SETTEXT                      =#000C
global constant WM_GETTEXT                      =#000D
global constant WM_GETTEXTLENGTH                =#000E
global constant WM_PAINT                        =#000F
global constant WM_CLOSE                        =#0010
global constant WM_QUERYENDSESSION              =#0011
global constant WM_QUIT                         =#0012
global constant WM_QUERYOPEN                    =#0013
global constant WM_ERASEBKGND                   =#0014
global constant WM_SYSCOLORCHANGE               =#0015
global constant WM_ENDSESSION                   =#0016
global constant WM_SHOWWINDOW                   =#0018
global constant WM_WININICHANGE                 =#001A
global constant WM_DEVMODECHANGE                =#001B
global constant WM_ACTIVATEAPP                  =#001C
global constant WM_FONTCHANGE                   =#001D
global constant WM_TIMECHANGE                   =#001E
global constant WM_CANCELMODE                   =#001F
global constant WM_SETCURSOR                    =#0020
global constant WM_MOUSEACTIVATE                =#0021
global constant WM_CHILDACTIVATE                =#0022
global constant WM_QUEUESYNC                    =#0023
global constant WM_GETMINMAXINFO                =#0024
global constant WM_PAINTICON                    =#0026
global constant WM_ICONERASEBKGND               =#0027
global constant WM_NEXTDLGCTL                   =#0028
global constant WM_SPOOLERSTATUS                =#002A
global constant WM_DRAWITEM                     =#002B
global constant WM_MEASUREITEM                  =#002C
global constant WM_DELETEITEM                   =#002D
global constant WM_VKEYTOITEM                   =#002E
global constant WM_CHARTOITEM                   =#002F
global constant WM_SETFONT                      =#0030
global constant WM_GETFONT                      =#0031
global constant WM_SETHOTKEY                    =#0032
global constant WM_GETHOTKEY                    =#0033
global constant WM_QUERYDRAGICON                =#0037
global constant WM_COMPAREITEM                  =#0039
global constant WM_COMPACTING                   =#0041
global constant WM_COMMNOTIFY                   =#0044  --no longer suported
global constant WM_WINDOWPOSCHANGING            =#0046
global constant WM_WINDOWPOSCHANGED             =#0047
global constant WM_POWER                        =#0048
global constant WM_COPYDATA                     =#004A
global constant WM_CANCELJOURNAL                =#004B
global constant WM_NOTIFY                       =#004E
global constant WM_INPUTLANGCHANGEREQUEST       =#0050
global constant WM_INPUTLANGCHANGE              =#0051
global constant WM_TCARD                        =#0052
global constant WM_HELP                         =#0053
global constant WM_USERCHANGED                  =#0054
global constant WM_NOTIFYFORMAT                 =#0055
global constant WM_CONTEXTMENU                  =#007B
global constant WM_STYLECHANGING                =#007C
global constant WM_STYLECHANGED                 =#007D
global constant WM_DISPLAYCHANGE                =#007E
global constant WM_GETICON                      =#007F
global constant WM_SETICON                      =#0080
global constant WM_NCCREATE                     =#0081
global constant WM_NCDESTROY                    =#0082
global constant WM_NCCALCSIZE                   =#0083
global constant WM_NCHITTEST                    =#0084
global constant WM_NCPAINT                      =#0085
global constant WM_NCACTIVATE                   =#0086
global constant WM_GETDLGCODE                   =#0087
global constant WM_NCMOUSEMOVE                  =#00A0
global constant WM_NCLBUTTONDOWN                =#00A1
global constant WM_NCLBUTTONUP                  =#00A2
global constant WM_NCLBUTTONDBLCLK              =#00A3
global constant WM_NCRBUTTONDOWN                =#00A4
global constant WM_NCRBUTTONUP                  =#00A5
global constant WM_NCRBUTTONDBLCLK              =#00A6
global constant WM_NCMBUTTONDOWN                =#00A7
global constant WM_NCMBUTTONUP                  =#00A8
global constant WM_NCMBUTTONDBLCLK              =#00A9
global constant WM_KEYFIRST                     =#0100
global constant WM_KEYDOWN                      =#0100
global constant WM_KEYUP                        =#0101
global constant WM_CHAR                         =#0102
global constant WM_DEADCHAR                     =#0103
global constant WM_SYSKEYDOWN                   =#0104
global constant WM_SYSKEYUP                     =#0105
global constant WM_SYSCHAR                      =#0106
global constant WM_SYSDEADCHAR                  =#0107
global constant WM_KEYLAST                      =#0108
global constant WM_IME_STARTCOMPOSITION         =#010D
global constant WM_IME_ENDCOMPOSITION           =#010E
global constant WM_IME_COMPOSITION              =#010F
global constant WM_IME_KEYLAST                  =#010F
global constant WM_INITDIALOG                   =#0110
global constant WM_COMMAND                      =#0111
global constant WM_SYSCOMMAND                   =#0112
global constant WM_TIMER                        =#0113
global constant WM_HSCROLL                      =#0114
global constant WM_VSCROLL                      =#0115
global constant WM_INITMENU                     =#0116
global constant WM_INITMENUPOPUP                =#0117
global constant WM_MENUSELECT                   =#011F
global constant WM_MENUCHAR                     =#0120
global constant WM_ENTERIDLE                    =#0121
global constant WM_CTLCOLORMSGBOX               =#0132
global constant WM_CTLCOLOREDIT                 =#0133
global constant WM_CTLCOLORLISTBOX              =#0134
global constant WM_CTLCOLORBTN                  =#0135
global constant WM_CTLCOLORDLG                  =#0136
global constant WM_CTLCOLORSCROLLBAR            =#0137
global constant WM_CTLCOLORSTATIC               =#0138
global constant WM_MOUSEFIRST                   =#0200
global constant WM_MOUSEMOVE                    =#0200
global constant WM_LBUTTONDOWN                  =#0201
global constant WM_LBUTTONUP                    =#0202
global constant WM_LBUTTONDBLCLK                =#0203
global constant WM_RBUTTONDOWN                  =#0204
global constant WM_RBUTTONUP                    =#0205
global constant WM_RBUTTONDBLCLK                =#0206
global constant WM_MBUTTONDOWN                  =#0207
global constant WM_MBUTTONUP                    =#0208
global constant WM_MBUTTONDBLCLK                =#0209
global constant WM_MOUSEWHEEL                   =#020A
global constant WM_MOUSELAST                    =#0209
global constant WM_PARENTNOTIFY                 =#0210
global constant WM_ENTERMENULOOP                =#0211
global constant WM_EXITMENULOOP                 =#0212
global constant WM_NEXTMENU                     =#0213
global constant WM_SIZING                       =#0214
global constant WM_CAPTURECHANGED               =#0215
global constant WM_MOVING                       =#0216
global constant WM_POWERBROADCAST               =#0218
global constant WM_DEVICECHANGE                 =#0219
global constant WM_IME_SETCONTEXT               =#0281
global constant WM_IME_NOTIFY                   =#0282
global constant WM_IME_CONTROL                  =#0283
global constant WM_IME_COMPOSITIONFULL          =#0284
global constant WM_IME_SELECT                   =#0285
global constant WM_IME_CHAR                     =#0286
global constant WM_IME_KEYDOWN                  =#0290
global constant WM_IME_KEYUP                    =#0291
global constant WM_MDICREATE                    =#0220
global constant WM_MDIDESTROY                   =#0221
global constant WM_MDIACTIVATE                  =#0222
global constant WM_MDIRESTORE                   =#0223
global constant WM_MDINEXT                      =#0224
global constant WM_MDIMAXIMIZE                  =#0225
global constant WM_MDITILE                      =#0226
global constant WM_MDICASCADE                   =#0227
global constant WM_MDIICONARRANGE               =#0228
global constant WM_MDIGETACTIVE                 =#0229
global constant WM_MDISETMENU                   =#0230
global constant WM_ENTERSIZEMOVE                =#0231
global constant WM_EXITSIZEMOVE                 =#0232
global constant WM_DROPFILES                    =#0233
global constant WM_MDIREFRESHMENU               =#0234
global constant WM_MOUSEHOVER                   =#02A1
global constant WM_MOUSELEAVE                   =#02A3
global constant WM_CUT                          =#0300
global constant WM_COPY                         =#0301
global constant WM_PASTE                        =#0302
global constant WM_CLEAR                        =#0303
global constant WM_UNDO                         =#0304
global constant WM_RENDERFORMAT                 =#0305
global constant WM_RENDERALLFORMATS             =#0306
global constant WM_DESTROYCLIPBOARD             =#0307
global constant WM_DRAWCLIPBOARD                =#0308
global constant WM_PAINTCLIPBOARD               =#0309
global constant WM_VSCROLLCLIPBOARD             =#030A
global constant WM_SIZECLIPBOARD                =#030B
global constant WM_ASKCBFORMATNAME              =#030C
global constant WM_CHANGECBCHAIN                =#030D
global constant WM_HSCROLLCLIPBOARD             =#030E
global constant WM_QUERYNEWPALETTE              =#030F
global constant WM_PALETTEISCHANGING            =#0310
global constant WM_PALETTECHANGED               =#0311
global constant WM_HOTKEY                       =#0312
global constant WM_PRINT                        =#0317
global constant WM_PRINTCLIENT                  =#0318
global constant WM_HANDHELDFIRST                =#0358
global constant WM_HANDHELDLAST                 =#035F
global constant WM_AFXFIRST                     =#0360
global constant WM_AFXLAST                      =#037F
global constant WM_PENWINFIRST                  =#0380
global constant WM_PENWINLAST                   =#038F

global constant WS_OVERLAPPED    =#00000000
global constant WS_POPUP         =#80000000
global constant WS_CHILD         =#40000000
global constant WS_MINIMIZE      =#20000000
global constant WS_VISIBLE       =#10000000
global constant WS_DISABLED      =#08000000
global constant WS_CLIPSIBLINGS  =#04000000
global constant WS_CLIPCHILDREN  =#02000000
global constant WS_MAXIMIZE      =#01000000
global constant WS_CAPTION       =#00C00000
global constant WS_BORDER        =#00800000
global constant WS_DLGFRAME      =#00400000
global constant WS_VSCROLL       =#00200000
global constant WS_HSCROLL       =#00100000
global constant WS_SYSMENU       =#00080000
global constant WS_THICKFRAME    =#00040000
global constant WS_GROUP         =#00020000
global constant WS_TABSTOP       =#00010000
global constant WS_MINIMIZEBOX   =#00020000
global constant WS_MAXIMIZEBOX   =#00010000


global constant WS_EX_MDICHILD         =#00000040
global constant WS_EX_TOOLWINDOW       =#00000080
global constant WS_EX_WINDOWEDGE       =#00000100
global constant WS_EX_CLIENTEDGE       =#00000200
global constant WS_EX_CONTEXTHELP      =#00000400
global constant WS_EX_RIGHT            =#00001000
global constant WS_EX_LEFT             =#00000000
global constant WS_EX_RTLREADING       =#00002000
global constant WS_EX_LTRREADING       =#00000000
global constant WS_EX_LEFTSCROLLBAR    =#00004000
global constant WS_EX_RIGHTSCROLLBAR   =#00000000
global constant WS_EX_CONTROLPARENT    =#00010000
global constant WS_EX_STATICEDGE       =#00020000
global constant WS_EX_APPWINDOW        =#00040000

global constant DISP_CHANGE_SUCCESSFUL=0
global constant CDS_FULLSCREEN =4 
global constant DM_BITSPERPEL       =#00040000
global constant DM_COLLATE          =#00008000
global constant DM_COLOR            =#00000800
global constant DM_COPIES           =#00000100
global constant DM_DEFAULTSOURCE    =#00000200
global constant DM_DISPLAYFLAGS     =#00200000
global constant DM_DISPLAYFREQUENCY =#00400000
global constant DM_DITHERTYPE       =#04000000
global constant DM_DUPLEX           =#00001000
global constant DM_FORMNAME         =#00010000
global constant DM_GRAYSCALE        =#00000001  --# This flag is no longer valid
global constant DM_ICMINTENT        =#01000000
global constant DM_ICMMETHOD        =#00800000
global constant DM_INTERLACED       =#00000002  --# This flag is no longer valid
global constant DM_LOGPIXELS        =#00020000
global constant DM_MEDIATYPE        =#02000000
global constant DM_NUP              =#00000040
global constant DM_ORIENTATION      =#00000001
global constant DM_PANNINGHEIGHT    =#10000000
global constant DM_PANNINGWIDTH     =#08000000
global constant DM_PAPERLENGTH      =#00000004
global constant DM_PAPERSIZE        =#00000002
global constant DM_PAPERWIDTH       =#00000008
global constant DM_PELSHEIGHT       =#00100000
global constant DM_PELSWIDTH        =#00080000
global constant DM_POSITION         =#00000020
global constant DM_PRINTQUALITY     =#00000400
global constant DM_SCALE            =#00000010
global constant DM_SPECVERSION      =#0401
global constant DM_TTOPTION         =#00004000
global constant DM_YRESOLUTION      =#00002000



global constant CS_VREDRAW =#0001
global constant CS_HREDRAW =#0002
global constant CS_DBLCLKS =#0008
global constant CS_OWNDC =#0020
global constant CS_CLASSDC =#0040
global constant CS_PARENTDC =#0080
global constant CS_NOCLOSE =#0200
global constant CS_SAVEBITS =#0800
global constant CS_BYTEALIGNCLIENT =#1000
global constant CS_BYTEALIGNWINDOW =#2000
global constant CS_GLOBALCLASS =#4000

global constant PFD_TYPE_RGBA=0
global constant PFD_TYPE_COLORINDEX=1
global constant PFD_MAIN_PLANE=0
global constant PFD_OVERLAY_PLANE=1
global constant PFD_UNDERLAY_PLANE=0
global constant PFD_DOUBLEBUFFER=1
global constant PFD_STEREO=2
global constant PFD_DRAW_TO_WINDOW=4
global constant PFD_DRAW_TO_BITMAP=8
global constant PFD_SUPPORT_GDI=16
global constant PFD_SUPPORT_OPENGL=32
global constant PFD_GENERIC_FORMAT=64
global constant PFD_NEED_PALETTE=128
global constant PFD_NEED_SYSTEM_PALETTE=256
global constant PFD_SWAP_EXCHANGE=512
global constant PFD_SWAP_COPY=1024
global constant PFD_SWAP_LAYER_BUFFERS=2048
global constant PFD_GENERIC_ACCELERATED=4096
global constant PFD_SUPPORT_DIRECTDRAW=8192
global constant PFD_DEPTH_DONTCARE=536870912
global constant PFD_DOUBLEBUFFER_DONTCARE=1073741824
global constant PFD_STEREO_DONTCARE=2147483648

global constant wglShareLists_=define_c_func(opengl32,"wglShareLists",{C_POINTER,C_POINTER},C_INT)
global constant wglGetCurrentDC_=define_c_func(opengl32,"wglGetCurrentDC",{},C_POINTER)
global constant wglGetCurrentContext_=define_c_func(opengl32,"wglGetCurrentContext",{},C_POINTER)
global constant wglGetProcAddress_=define_c_func(opengl32,"wglGetProcAddress",{C_POINTER},C_POINTER)
global constant ChoosePixelFormat_=define_c_func(gdi32,"ChoosePixelFormat",{C_UINT,C_POINTER},C_INT)
global constant GetObject_=define_c_func(gdi32,"GetObjectA",{C_POINTER,C_POINTER,C_POINTER},C_INT)
global constant DeleteObject_=define_c_func(gdi32,"DeleteObject",{C_POINTER},C_INT)
global constant SetPixelFormat_=define_c_func(gdi32,"SetPixelFormat",{C_UINT,C_INT,C_POINTER},C_UINT)
global constant GetPixelFormat_=define_c_func(gdi32,"GetPixelFormat",{C_POINTER},C_INT)
global constant DescribePixelFormat_=define_c_func(gdi32,"DescribePixelFormat",{C_UINT,C_UINT,C_UINT,C_POINTER},C_INT)
global constant GetDC_=define_c_func(user32,"GetDC",{C_INT},C_UINT)
global constant SetWindowText_=define_c_func(user32,"SetWindowTextA",{C_POINTER,C_POINTER},C_INT)
global constant LoadIcon_=define_c_func(user32,"LoadIconA",{C_POINTER,C_POINTER},C_POINTER)
global constant LoadImage_=define_c_func(user32,"LoadImageA",{C_POINTER,C_POINTER,C_POINTER,C_INT,C_INT,C_UINT},C_POINTER)
global constant LoadCursor_=define_c_func(user32,"LoadCursorA",{C_POINTER,C_POINTER},C_POINTER)
global constant ReleaseDC_=define_c_func(user32,"ReleaseDC",{C_UINT,C_UINT},C_INT)
global constant DestroyWindow_=define_c_func(user32,"DestroyWindow",{C_UINT},C_INT)
global constant wglCreateContext_=define_c_func(opengl32,"wglCreateContext",{C_UINT},C_INT)
global constant wglDeleteContext_=define_c_func(opengl32,"wglDeleteContext",{C_UINT},C_INT)
global constant wglMakeCurrent_=define_c_func(opengl32,"wglMakeCurrent",{C_UINT,C_UINT},C_INT)
global constant DefWindowProc_=define_c_func(user32,"DefWindowProcA",{C_UINT,C_UINT,C_UINT,C_UINT},C_INT)
global constant RegisterClass_=define_c_func(user32,"RegisterClassA",{C_POINTER},C_UINT)
global constant UnregisterClass_=define_c_func(user32,"UnregisterClassA",{C_POINTER,C_POINTER},C_INT)
global constant ChangeDisplaySettings_=define_c_func(user32,"ChangeDisplaySettingsA",{C_UINT,C_POINTER},C_INT)
global constant AdjustWindowRectEx_=define_c_func(user32,"AdjustWindowRectEx",{C_POINTER,C_UINT,C_INT,C_UINT},C_INT)
global constant CreateWindowEx_=define_c_func(user32,"CreateWindowExA",repeat(C_POINTER,4)&repeat(C_INT,4)&repeat(C_UINT,4),C_UINT)
global constant QueryPerformanceCounter_=define_c_func(kernel32,"QueryPerformanceCounter",{C_POINTER},C_INT)
global constant QueryPerformanceFrequency_=define_c_func(kernel32,"QueryPerformanceFrequency",{C_POINTER},C_INT)
global constant LoadLibrary_=define_c_func(kernel32,"LoadLibraryA",{C_POINTER},C_POINTER)
global constant GetModuleHandle_=define_c_func(kernel32,"GetModuleHandleA",{C_POINTER},C_POINTER)
global constant GetProcAddress_=define_c_func(kernel32,"GetProcAddress",{C_POINTER,C_POINTER},C_POINTER)
global constant ShowWindow_=define_c_func(user32,"ShowWindow",{C_POINTER,C_POINTER},C_INT)
global constant SetForegroundWindow_=define_c_func(user32,"SetForegroundWindow",{C_POINTER},C_INT)
global constant SetFocus_=define_c_func(user32,"SetFocus",{C_POINTER},C_POINTER)
global constant PeekMessage_=define_c_func(user32,"PeekMessageA",repeat(C_POINTER,5),C_POINTER)
global constant PostQuitMessage_=define_c_proc(user32,"PostQuitMessage",{C_INT})
global constant TranslateMessage_=define_c_func(user32,"TranslateMessage",{C_POINTER},C_INT)
global constant DispatchMessage_=define_c_func(user32,"DispatchMessageA",{C_POINTER},C_INT)
global constant SwapBuffers_=define_c_func(gdi32,"SwapBuffers",{C_INT},C_INT)
global constant ShowCursor_=define_c_func(user32,"ShowCursor",{C_INT},C_INT)

global function ShowCursor(atom bShow)
	return c_func(ShowCursor_,{bShow})
end function

global function SwapBuffers(atom hdc)
	return c_func(SwapBuffers_,{hdc})
end function

global function allocate_pfd(sequence spfd)
atom pfd
	pfd=allocatez(40)
	if length(spfd)=0 then return pfd end if
	if length(spfd)!=26 then ? 1/0 end if
poke4(pfd,40)--0  WORD  nSize; 
poke4(pfd+2,1)--2  WORD  nVersion; 
poke4(pfd+4,spfd[3])--4  DWORD dwFlags; 
poke(pfd+8,spfd[4])--8  BYTE  iPixelType; 
poke(pfd+9,spfd[5])--9  BYTE  cColorBits; 
poke(pfd+10,spfd[6])--10  BYTE  cRedBits; 
poke(pfd+11,spfd[7])--11  BYTE  cRedShift; 
poke(pfd+12,spfd[8])--12  BYTE  cGreenBits; 
poke(pfd+13,spfd[9])--13  BYTE  cGreenShift; 
poke(pfd+14,spfd[10])--14  BYTE  cBlueBits; 
poke(pfd+15,spfd[11])--15  BYTE  cBlueShift; 
poke(pfd+16,spfd[12])--16  BYTE  cAlphaBits; 
poke(pfd+17,spfd[13])--17  BYTE  cAlphaShift; 
poke(pfd+18,spfd[14])--18  BYTE  cAccumBits; 
poke(pfd+19,spfd[15])--19  BYTE  cAccumRedBits; 
poke(pfd+20,spfd[16])--20  BYTE  cAccumGreenBits; 
poke(pfd+21,spfd[17])--21  BYTE  cAccumBlueBits; 
poke(pfd+22,spfd[18])--22  BYTE  cAccumAlphaBits; 
poke(pfd+23,spfd[19])--23  BYTE  cDepthBits; 
poke(pfd+24,spfd[20])--24  BYTE  cStencilBits; 
poke(pfd+25,spfd[21])--25  BYTE  cAuxBuffers; 
poke(pfd+26,spfd[22])--26  BYTE  iLayerType; 
poke(pfd+27,spfd[23])--27  BYTE  bReserved; 
poke4(pfd+28,spfd[24])--28  DWORD dwLayerMask; 
poke4(pfd+32,spfd[25])--32  DWORD dwVisibleMask; 
poke4(pfd+34,spfd[26])--34  DWORD dwDamageMask; 
--38} PIXELFORMATDESCRIPTOR; 
	return pfd
end function

global function DeleteObject(atom hObject )
	return c_func(DeleteObject_,{hObject})
end function

global function GetObject(atom hgdiobj , atom cbBuffer , atom lpvObject )
	return c_func(GetObject_,{hgdiobj ,cbBuffer, lpvObject  })
end function

global function ChoosePixelFormat(atom hdc,object PIXELFORMATDESCRIPTOR)
	return c_func(ChoosePixelFormat_,{hdc,PIXELFORMATDESCRIPTOR})
end function

global function easy_ChoosePixelFormat(atom hdc, sequence spfd)
atom pfd,ret
pfd=allocate_pfd(spfd)
ret=ChoosePixelFormat(hdc,pfd)
free(pfd)
return ret
end function

global function SetPixelFormat(atom hdc,atom fqqej,object PIXELFORMATDESCRIPTOR)
	return c_func(SetPixelFormat_,{hdc,fqqej,PIXELFORMATDESCRIPTOR})
end function

global function GetPixelFormat(atom hdc)
	return c_func(GetPixelFormat_,{hdc})
end function

global function easy_SetPixelFormat(atom hdc, atom iPixelFormat, sequence spfd)
atom pfd,ret
pfd=allocate_pfd(spfd)
ret=SetPixelFormat(hdc,iPixelFormat,pfd)
free(pfd)
return ret
end function

global function DescribePixelFormat(atom hdc,atom iPixelFormat,atom nBytes,object ppfd)
	return c_func(DescribePixelFormat_,{hdc,iPixelFormat,nBytes,ppfd})
end function


global function easy_DescribePixelFormat(atom hdc, atom iPixelFormat)
atom pfd,ret
pfd=allocatez(40)
ret=DescribePixelFormat(hdc,iPixelFormat,40,pfd)
free(pfd)
return ret
end function

global function GetModuleHandle(atom lpModuleName)
	return c_func(GetModuleHandle_,{lpModuleName})
end function


global function easy_LoadLibrary(sequence name)
atom mem,ret
mem=allocate_string(name)
ret=c_func(LoadLibrary_,{mem})
freez(mem)
return ret
end function

global function GetProcAddress(atom mod, atom proc)
return c_func(GetProcAddress_,{mod,proc})
end function


global procedure PostQuitMessage(atom nExitCode)
	c_proc(PostQuitMessage_,{nExitCode})
end procedure

global function PeekMessage(atom lpMsg, atom hWnd, atom wMsgFilterMin, atom wMsgFilterMax, atom wRemoveMsg)
	return c_func(PeekMessage_,{lpMsg, hWnd, wMsgFilterMin, wMsgFilterMax, wRemoveMsg})
end function

global function TranslateMessage(atom lpMsg)
	return c_func(TranslateMessage_,{lpMsg})
end function

global function DispatchMessage(atom lpMsg)
	return c_func(DispatchMessage_,{lpMsg})
end function

global function SetFocus(atom hWnd)
	return c_func(SetFocus_,{hWnd})
end function

global function SetForegroundWindow(atom hWnd)
	return c_func(SetForegroundWindow_,{hWnd})
end function

global function ShowWindow(atom hWnd,atom nCmdShow)
	return c_func(ShowWindow_,{hWnd,nCmdShow})
end function

global function CreateWindowEx(
atom dwExStyle, atom lpClassName,atom lpWindowName, atom dwStyle, 
atom x, atom y, atom nWidth, atom nHeight,
atom hWndParent, atom hMenu, atom hInstance, atom lpParam)
return c_func(CreateWindowEx_,{
dwExStyle,lpClassName,lpWindowName,dwStyle,
x,y,nWidth,nHeight,
hWndParent,hMenu,hInstance,lpParam})
end function

global function easy_CreateWindowEx(
atom dwExStyle, object lpClassName,object lpWindowName, atom dwStyle, 
atom x, atom y, atom nWidth, atom nHeight,
atom hWndParent, atom hMenu, atom hInstance, atom lpParam)
atom allocated_class_name
atom allocated_window_name
atom ret
allocated_class_name=0
allocated_window_name=0
if sequence(lpClassName) then
	if length(lpClassName) then allocated_class_name=1 lpClassName=allocate_string(lpClassName) else lpClassName=0 end if
end if
if sequence(lpWindowName) then
	if length(lpWindowName) then allocated_window_name=1 lpWindowName=allocate_string(lpWindowName) else lpWindowName=0 end if
end if
ret=c_func(CreateWindowEx_,{
dwExStyle,lpClassName,lpWindowName,dwStyle,
x,y,nWidth,nHeight,
hWndParent,hMenu,hInstance,lpParam})
if allocated_class_name then freez(lpClassName) end if
if allocated_window_name then freez(lpWindowName) end if
return ret
end function



global function AdjustWindowRectEx(atom lpRect, atom dwStyle,atom bMenu, atom dwExStyle)
	return c_func(AdjustWindowRectEx_,{lpRect, dwStyle,bMenu, dwExStyle})
end function


global function ChangeDisplaySettings(atom lpDevMode, atom dwflags)
	return c_func(ChangeDisplaySettings_,{lpDevMode,dwflags})
end function

global function RegisterClass(atom lpWndClass)
	return c_func(RegisterClass_,{lpWndClass})
end function

global function UnregisterClass(atom lpClassName, atom hInstance)
	return c_func(UnregisterClass_,{lpClassName, hInstance})
end function

global function easy_UnregisterClass(object lpClassName, atom hInstance)
atom ret
	if sequence(lpClassName) and length(lpClassName)=0 then lpClassName=0 end if
	if atom(lpClassName) then return UnregisterClass(lpClassName,hInstance) end if
	lpClassName=allocate_string(lpClassName)
	ret=UnregisterClass(lpClassName,hInstance)
	free(lpClassName)
	return ret
end function

global function DefWindowProc(atom hWnd, atom Msg, atom wParam, atom lParam)
	return c_func(DefWindowProc_,{hWnd,Msg,wParam,lParam})
end function

global function wglShareLists(atom hglrc1, atom hglrc2)
	return c_func(wglShareLists_,{hglrc1,hglrc2})
end function

global function wglGetCurrentDC()
	return c_func(wglGetCurrentDC_,{})
end function

global function wglGetCurrentContext()
	return c_func(wglGetCurrentContext_,{})
end function

global function wglMakeCurrent(atom hdc,atom hglrc)
	return c_func(wglMakeCurrent_,{hdc,hglrc})
end function

global function wglCreateContext(atom hdc)
	return c_func(wglCreateContext_,{hdc})
end function

global function wglDeleteContext(atom hglrc)
	return c_func(wglDeleteContext_,{hglrc})
end function

global function LoadCursor(atom hInstance, atom lpCursorName)
	return c_func(LoadCursor_,{hInstance,lpCursorName})
end function

global function easy_LoadImage(atom hinst, object lpszName, atom uType, atom cxDesired, atom cyDesired, atom fuLoad)
atom ret
	if sequence(lpszName) and not length(lpszName) then lpszName=0 end if
	if atom(lpszName) then return c_func(LoadImage_,{hinst, lpszName, uType, cxDesired, cyDesired, fuLoad}) end if
	lpszName=allocate_string(lpszName)
	ret=c_func(LoadImage_,{hinst, lpszName, uType, cxDesired, cyDesired, fuLoad})
	free(lpszName)
	return ret
end function

global function LoadIcon(atom hInstance, atom lpIconName)
	return c_func(LoadIcon_,{hInstance,lpIconName})
end function

global function easy_SetWindowText(atom hWnd, object text)
atom ret
	if length(text)=0 then text=0 end if
	if atom(text) then return c_func(SetWindowText_,{hWnd,text}) end if
	text=allocate_string(text)
	ret=c_func(SetWindowText_,{hWnd,text})
	free(text)
	return ret
end function

global function GetDC(atom hWnd)
	return c_func(GetDC_,{hWnd})
end function

global function DestroyWindow(atom hWnd)
	return c_func(DestroyWindow_,{hWnd})
end function

global function ReleaseDC(atom hWnd, atom hDC)
	return c_func(ReleaseDC_,{hWnd,hDC})
end function




global function peek_pfd(atom pfd)
	return
	word(peek({pfd,2}))&
	word(peek({pfd+2,2}))&
	peek4u(pfd+4)&
	peek({pfd+8,21})&
	peek4u({pfd+28,3})
end function


global function allocate_WNDCLASS(sequence swc)
atom wc
wc=allocatez(40)
if length(swc)=0 then return wc end if
if length(swc)!=10 then ? 1/0 end if
if sequence(swc[9]) then if length(swc[9]) then swc[9]=allocate_string(swc[9]) else swc[9]=0 end if end if
if sequence(swc[10]) then if length(swc[10]) then swc[10]=allocate_string(swc[10]) else swc[10]=0 end if end if
-- typedef struct {
poke4(wc,swc)--0     UINT style;
--4     WNDPROC lpfnWndProc;
--8     int cbClsExtra;
--12     int cbWndExtra;
--16     HINSTANCE hInstance;
--20     HICON hIcon;
--24     HCURSOR hCursor;
--28     HBRUSH hbrBackground;
--32     LPCTSTR lpszMenuName;
--36     LPCTSTR lpszClassName;
--40 } WNDCLASS, *PWNDCLASS;
return wc
end function

global constant CCHDEVICENAME=32,CCHFORMNAME=32

global function allocate_DEVMODE(sequence sdm)
atom dm
dm=allocatez(156)
return dm
-- typedef struct _devicemode { 
--0   BCHAR  dmDeviceName[CCHDEVICENAME]; 
--32   WORD   dmSpecVersion; 
--34   WORD   dmDriverVersion; 
--36   WORD   dmSize; 
--38   WORD   dmDriverExtra; 
--40   DWORD  dmFields; 
--44     POINTL dmPosition;
--52     DWORD  dmDisplayOrientation;
--56     DWORD  dmDisplayFixedOutput;
--60   short  dmColor; 
--62   short  dmDuplex; 
--64   short  dmYResolution; 
--66   short  dmTTOption; 
--68   short  dmCollate; 
--70   BYTE  dmFormName[CCHFORMNAME]; 
--102   WORD  dmLogPixels; 
--104   DWORD  dmBitsPerPel; 
--108   DWORD  dmPelsWidth; 
--112   DWORD  dmPelsHeight; 
--   union {
--116     DWORD  dmDisplayFlags; 
--     DWORD  dmNup;
--   }
--120   DWORD  dmDisplayFrequency; 
-- #if(WINVER >= =#0400) 
--124   DWORD  dmICMMethod;
--128   DWORD  dmICMIntent;
--132   DWORD  dmMediaType;
--136   DWORD  dmDitherType;
--140   DWORD  dmReserved1;
--144   DWORD  dmReserved2;
-- #if (WINVER >= =#0500) || (_WIN32_WINNT >= =#0400)
--148   DWORD  dmPanningWidth;
--152   DWORD  dmPanningHeight;
-- #endif
-- #endif /* WINVER >= =#0400 */
-- 156} DEVMODE; 
end function

global function allocate_LPRECT(sequence srect)
atom rect
rect=allocatez(4*4)
if length(srect)=0 then return rect end if
if length(srect)!=4 then ? 1/0 end if
poke4(rect,srect)
return rect
end function

global function allocate_MSG(sequence smsg)
atom msg
msg=allocatez(28)
return msg
-- typedef struct {
--0     HWND hwnd;
--4     UINT message;
--8     WPARAM wParam;
--12     LPARAM lParam;
--16     DWORD time;
--20     POINT pt;
--28 } MSG, *PMSG;
end function

global function allocate_glint(atom val)
atom ret
	ret=allocatez(4) poke4(ret,val)
	return ret
end function

global function peek_free_glint(atom ptr)
atom ret
	ret=peek4s(ptr) freez(ptr)
	return ret
end function

